import { IObject } from '../adapter';
import { Agent } from '../agent';
import type { CalleeBroker } from '../brokers';
export declare class CalleeAgent<T extends IObject> extends Agent<CalleeBroker> {
    protected readonly target: T;
    protected readonly deep: boolean;
    constructor(target: T, options: CalleeAgent.Options);
    protected onDeferred: CalleeBroker.MessageHandler;
    protected onBatched: CalleeBroker.MessageHandler;
    /**
     * Inject target as agent
     */
    inject(): void;
    /**
     * Eject agent
     */
    eject(): void;
}
export declare namespace CalleeAgent {
    interface Options {
        key: string;
        broker: CalleeBroker;
        deep?: boolean;
    }
}
