import { IObject } from '../adapter';
import { Agent } from '../agent';
import { CallerBroker } from '../brokers';
export declare class DeferredCallerAgent<T extends IObject> extends Agent<CallerBroker> implements ProxyHandler<T>, PromiseLike<any> {
    protected readonly instructions: DeferredCallerAgent.Instruction[];
    constructor(options: DeferredCallerAgent.Options);
    get(target: T, p: string | symbol): any;
    set(target: T, p: string | symbol, newValue: any): boolean;
    apply(target: T, thisArg: any, argArray: any[]): any;
    getPrototypeOf(): object;
    then<TResult1 = any, TResult2 = never>(onfulfilled?: (value: any) => TResult1 | PromiseLike<TResult1>, onrejected?: (reason: any) => TResult2 | PromiseLike<TResult2>): PromiseLike<TResult1 | TResult2>;
}
export declare namespace DeferredCallerAgent {
    interface Options {
        key: string;
        broker: CallerBroker;
        instructions?: DeferredCallerAgent.Instruction[];
    }
    type Instruction = Instruction.Get | Instruction.Set | Instruction.Apply;
    namespace Instruction {
        interface Get {
            t: 'get';
            p: string | number;
        }
        interface Set {
            t: 'set';
            p: string | number;
            v: any;
        }
        interface Apply {
            t: 'apply';
            a?: any[];
        }
    }
}
