export interface BrokerMessage {
    /**
     * Message unique type
     */
    readonly type: string;
    /**
     * Message payload
     */
    readonly payload?: any;
}
export interface BrokerRequest extends BrokerMessage {
    /**
     * Message session ID
     */
    readonly id: string;
}
export interface BrokerResponse {
    /**
     * Message session ID
     */
    readonly id: string;
    /**
     * Error
     */
    readonly error?: any;
    /**
     * Response payload
     */
    readonly payload?: any;
}
export declare function isResponse(msg: unknown): msg is BrokerResponse;
export declare function isEvent(msg: unknown): msg is BrokerMessage;
export declare function isRequest(msg: unknown): msg is BrokerRequest;
